/**
 *
 * @author Yaochao
 * @version 1.0
 */
(function (tree) {
    tree.init = function (params) {
        var treeId = params.id;
        var data = params.data;
        var i = 0;
        var content = '<ul class="smys-tree">';
        for (i = 0; i < data.length; i++) {
            var node = data[i];
            content += '<span> <li class="trunk" id="n_' + node.id + '"><input type="checkbox">' + node.name + '</li>';
            var branches = node.branches;
            if (branches) {
                //有分支
                content += '<ul>';
                for (var j = 0; j < branches.length; j++) {
                    content += ' <li class="leaf" id="n_' + branches[j].id + '" pid="n_' + node.id + '"><input type="checkbox">' + branches[j].name + '</li><br>';
                }
                content += '</ul>';
            }
            content += '</span>';
        }
        content += '</ul>';
        document.querySelector('#' + treeId).innerHTML = content;
        var trucks = document.querySelectorAll('#' + treeId + ' .trunk');
        var leafs = document.querySelectorAll('#' + treeId + ' .leaf');

        function truckClick(trunk) {
            trunk.onclick = function (event) {
                var id = this.id;
                var check;
                if (event.target === this) {
                    var tcheck = this.getElementsByTagName('input')[0];
                    if (tcheck.checked) {
                        tcheck.checked = false;
                    } else {
                        tcheck.checked = true;
                    }
                    check = tcheck.checked;
                } else if (event.target.nodeName === 'INPUT') {
                    check = event.target.checked;
                }
                var leaf = document.querySelectorAll("#" + treeId + " [pid='" + id + "']");
                for (i = 0; i < leaf.length; i++) {
                    var lcheck = leaf[i].getElementsByTagName('input')[0];
                    lcheck.checked = check;
                }
            };
        }

        function leafClick(leaf) {
            leaf.onclick = function (event) {
                if (event.target === this) {
                    var check = this.getElementsByTagName('input')[0];
                    if (check.checked) {
                        check.checked = false;
                    } else {
                        check.checked = true;
                    }
                }
                var truckId = this.getAttribute('pid');
                var leafs = document.querySelectorAll("#" + treeId + " [pid='" + truckId + "']");
                var hasChecked = false;
                for (i = 0; i < leafs.length; i++) {
                    if (leafs[i].getElementsByTagName('input')[0].checked) {
                        hasChecked = true;
                    }
                }
                document.querySelector("#" + treeId + " #" + truckId + " input").checked = hasChecked;
            };
        }

        for (i = 0; i < trucks.length; i++) {
            truckClick(trucks[i]);
        }

        for (i = 0; i < leafs.length; i++) {
            leafClick(leafs[i]);
        }
    };

    tree.getSelectedNodes = function (treeId) {
        var leafs = document.querySelectorAll('#' + treeId + ' .leaf');
        var selects = [];
        for (var i = 0; i < leafs.length; i++) {
            if (leafs[i].getElementsByTagName('input')[0].checked) {
                var leafId = leafs[i].id.substring(2);
                var leafNameStr =document.getElementById(leafs[i].id).innerHTML;
                var leafName =leafNameStr.substring(leafNameStr.indexOf(">")+1);
                var pId = leafs[i].getAttribute('pid').substring(2);
                var pNameStr =document.getElementById(leafs[i].getAttribute('pid')).innerHTML;
                var pName = pNameStr.substring(leafNameStr.indexOf(">")+1);
                // selects[selects.length] = leafId + "-" + pId;
                selects[selects.length] = '{"id":"' + leafId + '","name":"' + leafName + '","parent":{"id":"' + pId + '","name":"' + pName + '"}}';


            }
        }
        return selects;
    };
})(window.Tree = {});